using System;
using System.Workflow.ComponentModel;
using System.Workflow.Runtime;

namespace HelloWorld
{
    public class HelloWorld : Activity
    {
	private string text = "Hello, world.";

	protected override ActivityExecutionStatus Execute(ActivityExecutionContext context)
	{
		WorkflowQueuingService qs = context.GetService<WorkflowQueuingService>();
		WorkflowQueue q = qs.CreateWorkflowQueue("Q", true);
		q.QueueItemAvailable += Resume;

		Console.WriteLine("Execute finished");
		return ActivityExecutionStatus.Executing;

	}

	private void Resume(object sender, QueueEventArgs args)
	{

		Console.WriteLine("Execute resumed.");
		ActivityExecutionContext context = sender as ActivityExecutionContext;
		WorkflowQueuingService qs = context.GetService<WorkflowQueuingService>();
		WorkflowQueue q = qs.GetWorkflowQueue("Q");
		text = (string)q.Dequeue();
		qs.DeleteWorkflowQueue("Q");

		Console.WriteLine(text);

		context.CloseActivity();
	}
        
    } 
}
