using System;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

class Program
{
    
    static AutoResetEvent waitHandle = new AutoResetEvent(false);
    static WorkflowInstance instance;

    static void Main(string[] args)
    {
        WorkflowRuntime workflowRuntime = new WorkflowRuntime();
   
        // string connectionString = "Integrated Security=SSPI; Persist Security Info=False;Initial Catalog=WorkflowStore; Data Source= localhost";
	string connectionString = @"Integrated Security=SSPI; Persist Security Info=False;Initial Catalog=WorkflowPersistence; Data Source= localhost\SQLEXPRESS";

	workflowRuntime.AddService(new SqlWorkflowPersistenceService(connectionString));

        workflowRuntime.StartRuntime();

        workflowRuntime.WorkflowTerminated += new EventHandler<WorkflowTerminatedEventArgs>(WorkflowRuntime_WorkflowTerminated);
        workflowRuntime.WorkflowCompleted += new EventHandler<WorkflowCompletedEventArgs>(WorkflowRuntime_WorkflowCompleted);
        workflowRuntime.WorkflowIdled += new EventHandler<WorkflowEventArgs>(workflowRuntime_WorkflowIdled);			


        Type type = typeof(HelloWorld.HelloWorld);
        instance = workflowRuntime.CreateWorkflow(type);
        instance.Start();

	waitHandle.WaitOne();
        workflowRuntime.StopRuntime();
 
    }

    static void WorkflowRuntime_WorkflowCompleted(object sender, WorkflowCompletedEventArgs e)
    {
	Console.WriteLine("Workflow Completed.");
        waitHandle.Set();
    }

    static void WorkflowRuntime_WorkflowTerminated(object sender, WorkflowTerminatedEventArgs e)
    {
        Console.WriteLine(e.Exception.Message);
        waitHandle.Set();
    }

    static private void workflowRuntime_WorkflowIdled(object sender, WorkflowEventArgs e)
    {
	Console.WriteLine("Workflow {0} idled.", instance.InstanceId.ToString());
        instance.TryUnload();
	waitHandle.Set();
    }
}

