using System;
using System.Collections.Generic;
using System.Reflection;
using System.Threading;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.Runtime;
using System.Xml;

class Program
{
    static void Main(string[] args)
    {
        WorkflowRuntime workflowRuntime = new WorkflowRuntime();
        
        TypeProvider typeProvider = new TypeProvider(workflowRuntime);
        typeProvider.AddAssembly(Assembly.GetExecutingAssembly());
        workflowRuntime.AddService(typeProvider);

	workflowRuntime.StartRuntime();

        XmlReader reader = XmlReader.Create("test.xoml");
	
	Dictionary<string, object> parameters = new Dictionary<string, object>();
	parameters.Add("Message", "Hello, Bound Workflow");
        WorkflowInstance instance = workflowRuntime.CreateWorkflow(reader, null, parameters);
	instance.Start();
	
	Console.ReadLine();
        workflowRuntime.StopRuntime();
 
    }
}

