using System;
using System.Collections.ObjectModel;
using System.Workflow.ComponentModel;

namespace SequenceActivity
{
    public class Sequence: CompositeActivity
    {
        string message;

	    public string Message
	    {
            get { return message;}
            set { message = value;}
	    }
    	
	    protected override ActivityExecutionStatus Execute(ActivityExecutionContext context)
	    {
    		
		    if (EnabledActivities.Count == 0)
			    return ActivityExecutionStatus.Closed;

		    Activity currentActivity = EnabledActivities[0];
		    currentActivity.Closed += Resume;
		    context.ExecuteActivity(currentActivity);

		    return ActivityExecutionStatus.Executing;		

	    }

	    private void Resume(object sender, ActivityExecutionStatusChangedEventArgs args)
	    {

		    ActivityExecutionContext context = sender as ActivityExecutionContext;
		    args.Activity.Closed -= Resume;

		    Activity activity = args.Activity;
		    ReadOnlyCollection<Activity> enabledActivities = EnabledActivities;
		    int current = enabledActivities.IndexOf(activity);

		    if (current + 1 == EnabledActivities.Count)
			    context.CloseActivity();
		    else
		    {
			    Activity currentActivity = EnabledActivities[current + 1];
			    currentActivity.Closed += Resume;
			    context.ExecuteActivity(currentActivity);
		    }
	    }
       
    } 
}
