using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace LoanDecision
{
	public sealed partial class Decision: SequentialWorkflowActivity
	{
        double interestRate;
        double loanAmount;
        bool approved = false;

        public bool Approved
        {
            get { return approved; }
        }

        public double InterestRate
        {
            set { interestRate = value; }
        }

        public double LoanAmount
        {
            set { loanAmount = value; }
        }

		public Decision()
		{
			InitializeComponent();
		}

        private void EvaluateLargeLoan(object sender, ConditionalEventArgs e)
        {
            if (loanAmount > 250000)
                e.Result = true;
            else
                e.Result = false;
        }

        private void LargeLoan(object sender, EventArgs e)
        {
            double payment = (loanAmount * interestRate * .01 / 12);
            if (payment > 1500)
                approved = false;
            else
                approved = true;
        }

        private void SmallLoan(object sender, EventArgs e)
        {
            approved = true;
        }
	}

}
