using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

namespace LoanDecision
{
    class Program
    {
        static AutoResetEvent waitHandle = new AutoResetEvent(false);

        static void Main(string[] args)
        {
            WorkflowRuntime workflowRuntime = new WorkflowRuntime();

            workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e)
            {
                bool result = (bool)e.OutputParameters["Approved"];
                if (result == true)
                    Console.WriteLine("    Loan Approved.");
                else
                    Console.WriteLine("    Loan Denied");

                waitHandle.Set();
            };

            workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
            {
                Console.WriteLine(e.Exception.Message);
                workflowRuntime.StopRuntime();
                return;
            };

            Type type = typeof(LoanDecision.Decision);

            double loanAmount;
            double interestRate;
            string input;

            for (; ; )
            {
                waitHandle.Reset();

                Console.WriteLine("Enter loan information:");
                Console.Write("Loan Amount: ");
                input = Console.ReadLine();
                loanAmount = Double.Parse(input);
                if (loanAmount == -1)
                    break;
                Console.Write("Interest Rate: ");
                input = Console.ReadLine();
                interestRate = Double.Parse(input);

                Console.WriteLine("${0} loan requested at {1} percent.", loanAmount, interestRate);

                Dictionary<string, object> parameters = new Dictionary<string, object>();
                parameters.Add("InterestRate", interestRate);
                parameters.Add("LoanAmount", loanAmount);

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(type, parameters);
                Console.WriteLine("    Workflow instance {0} created.", instance.InstanceId);
                instance.Start();

                waitHandle.WaitOne();
            }

            workflowRuntime.StopRuntime();
            return;
        }
    }
}
