#region Using directives

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using ExternalMethod.Properties;
using System.Workflow.Activities;

#endregion

namespace ExternalMethod
{
    class Program
    {
        static void Main(string[] args)
        {
            WorkflowRuntime workflowRuntime = new WorkflowRuntime();
            
            AutoResetEvent waitHandle = new AutoResetEvent(false);
            workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
            workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
            {
                Console.WriteLine(e.Exception.Message);
                waitHandle.Set();
            };

            ExternalDataExchangeService service = new ExternalDataExchangeService();
            GatherInformation gatherInfo = new GatherInformation("Acme Financial");
            workflowRuntime.AddService(service);
            service.AddService(gatherInfo);

            WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(ExternalMethod.GatherInformationWorkflow));
            instance.Start();

            waitHandle.WaitOne();
        }
    }
}
