using System;
using System.Collections.Generic;
using System.Text;
using System.Workflow.Activities;
using System.Threading;

[Serializable]
public class GatherInformation : IGatherInformation
{
    string companyName;

    public event EventHandler<MessageEventArgs> SendInformation;

    public GatherInformation(string companyName)
    {
        this.companyName = companyName;
    }

    public void GatherInfo(Guid instanceId, string person, double loanAmount, double interestRate)
    {
        string message = String.Format("Information about {0}'s loan for ${1} at {2}%", person, loanAmount, interestRate);
        MessageEventArgs arg = new MessageEventArgs(instanceId, message);
        ThreadPool.QueueUserWorkItem(new WaitCallback(RaiseSendInformation), arg);     
    }

    private void RaiseSendInformation(object o)
    {
        if (SendInformation != null)
        {
            MessageEventArgs arg = o as MessageEventArgs;
            SendInformation(null, arg);
        }
    }
}


