using System;
using System.Collections.Generic;
using System.Text;
using System.Workflow.Activities;

[Serializable]
public class MessageEventArgs : ExternalDataEventArgs
{
    private string information;

    public MessageEventArgs(Guid instanceId, string information)
        : base(instanceId)
    {
        this.information = information;
    }

    public string Information
    {
        get { return information; }
    }
}

[ExternalDataExchange]
public interface IGatherInformation
{
    event EventHandler<MessageEventArgs> SendInformation;
    void GatherInfo(Guid instanceId, string person, double amount, double interestRate);
}


